/* alarm.r */

/*---------------------------------------------------------------------------------------------------------
	Demonstration Program: Timer Event Functions
---------------------------------------------------------------------------------------------------------*/

!include <sculptor.h>

!chargrid OFF

!temp AlarmTime,,i4,"HH:MM:SS"

/*-------------------------------------------------------------------------------------------------------*/

+window wintask at 120,80 {
	max_width = 380
	max_height = 230
	style = WS_CLOSEBUTTON | WS_HOTWINDOW
	title = "ALARM"
	event = wintaskEvent

	+textbox tbTimeNow at 140,30 {
		field = sys.Time
		label = "Time Now "
		format = "HH:MM:SS"
		style = WS_NOTABSTOP
	}

	+textbox tbAlarmTime at 140,70 {
		field = tmp.AlarmTime
		label = "Alarm "
		mode = EM_NOCLEAR
	}

	+text stWaitingForAlarm at 86,110 {
		label = "Waiting for alarm to ring..."
		label_font = "Arial@12,b"
		label_fgc = RGB_DARKRED
	}

	+text stPressESCtoExit at 43,140 {
		label = "To exit program: Press ESC or click X"
		label_font = "Arial@12,b"
		label_fgc = RGB_DARKGREEN
	}
}

/*********************************************************************************************************/

	tmp.AlarmTime->logical_type = LT_CTIME				/* Set field as clock time */

	/* Default alarm in 12 seconds */
	/* The user can type another time in */
	tmp.AlarmTime = sys.Time + 12

	display tbAlarmTime, tbTimeNow

	CreateTimer(AlarmTimerEvent, 1000, TIMER_START)		/* Timer event every second (1000ms) */

	dialog cancel=EXIT_PROGRAM							/* Remove cancel= to disable ESC key */

	DestroyTimer(AlarmTimerEvent)

	playsound("alarm.wav", SND_ASYNC | SND_LOOP)
	info "The alarm should be ringing"

EXIT_PROGRAM:
	exit

/*-------------------------------------------------------------------------------------------------------*/

!function AlarmTimerEvent() {

	/***
	It's normally necessary to stop the timer at the start of a timer event and to restart it, if
	required, before returning. This avoids the possibility of another timer event occurring before
	the current one has been processed. Recursive calls to this function can compromise the program
	logic but even if not, they can build up and eventually cause a stack overflow error.
	***/

	StopTimer(AlarmTimerEvent)

	display wintask.tbTimeNow

	if (sys.Time >= tmp.AlarmTime) {
		return CLOSE_DIALOG
	}

	StartTimer(AlarmTimerEvent)
}

/*-------------------------------------------------------------------------------------------------------*/

!function wintaskEvent(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		exit
	}
}

/*********************************************************************************************************/
